"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const node_crypto_1 = __importDefault(require("node:crypto"));
const node_fpe_1 = __importDefault(require("node-fpe"));
const Configuration_1 = __importDefault(require("../shared/config/Configuration"));
const NumberLength_1 = __importDefault(require("./NumberLength"));
class AbstractRandomNumber {
    constructor(NumberConfiguration) {
        this.setConfiguration(NumberConfiguration);
        this._length = new NumberLength_1.default();
        this._calculateLength();
        this._value = 0;
    }
    getConfiguration() {
        return this._configuration;
    }
    setConfiguration(NumberConfiguration) {
        this._validateConfigurationInstance(NumberConfiguration);
        this._configuration = NumberConfiguration;
    }
    getLength() {
        return this._length;
    }
    getValue() {
        return this._value;
    }
    _validateConfigurationInstance(NumberConfiguration) {
        if (!(NumberConfiguration instanceof Configuration_1.default)) {
            throw new Error('The NumberConfiguration param must be an instance of Configuration object');
        }
        return true;
    }
    _calculateLength() {
        const minLength = this._configuration.getMinLength().getValue();
        const maxLength = this._configuration.getMaxLength().getValue();
        this._length = new NumberLength_1.default(Math.floor(minLength + Math.random() * (maxLength + 1 - minLength)));
    }
    _increaseNumberRandomness(number) {
        const bytes = 256;
        const cipher = (0, node_fpe_1.default)({ password: node_crypto_1.default.randomBytes(bytes) });
        const random = cipher.encrypt(number.toString());
        if (random.toString().charAt(0) === '0') {
            return this._increaseNumberRandomness(number);
        }
        return parseInt(random);
    }
}
exports.default = AbstractRandomNumber;
