"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NumberLength = void 0;
const MAX_SAFE_LENGTH = Number.MAX_SAFE_INTEGER.toString().length;
class NumberLength {
    constructor(length = 0) {
        this._value = this.computeLength(length);
        return this;
    }
    static getMaxSafeLength() {
        return MAX_SAFE_LENGTH;
    }
    getValue() {
        return this._value;
    }
    computeLength(length) {
        let value = length;
        const maxLength = MAX_SAFE_LENGTH;
        if (length > 0 && length > maxLength) {
            value = maxLength;
        }
        else if (!length) {
            value = Math.floor(Math.random() * maxLength) + 1;
        }
        return value;
    }
}
exports.NumberLength = NumberLength;
exports.default = NumberLength;
